<?php
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// ShowInMain for phpWebSite by Jim Flowers (jflowers@ezo.net)
//
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Filename: index.php
// Original Author of file:	Shawn McKenzie (AbraCadaver)
//							Yassen Yotov (CyberOto)
// Purpose of file: Incorporate external sites or apps
// ----------------------------------------------------------------------

// PostNuke specific
	if (!defined("LOADED_AS_MODULE"))
	{
		die ("You can't access this file directly...");
	}
	$ModName = $GLOBALS['name'];
	modules_get_language();
	include("header.php");
		
// Module specific
	$allow_local_only = pnModGetVar($ModName, 'allow_local_only');
	$use_buffering = pnModGetVar($ModName, 'use_buffering');
	$use_compression = pnModGetVar($ModName, 'use_compression');
	$reg_user_only = pnModGetVar($ModName, 'reg_user_only');
	$no_user_entry = pnModGetVar($ModName, 'no_user_entry');
	$open_direct = pnModGetVar($ModName, 'open_direct');
	$use_fixed_title = pnModGetVar($ModName, 'use_fixed_title');
	$auto_resize = pnModGetVar($ModName, 'auto_resize');
	$vsize = pnModGetVar($ModName, 'vsize');
	$security = pnModGetVar($ModName, 'security');
	//Compatible for fenix 0.7.2.1 and higher
	$UseCompression = pnConfigGetVar('UseCompression');
	
// CyberOto [---Begin-----------------------------]
// Use DB to check URL
    if($security)
    {
		// Security check - important to do this as early on as possible to 
		// avoid potential security holes or just too much wasted processing
		if (!pnSecAuthAction(0, '::', '::', ACCESS_READ))
		{
			return array();
		}
		
		list($dbconn) = pnDBGetConn();
		$urltable = pnConfigGetVar('prefix') . '_postwrap_url';
		
		$result = $dbconn->Execute("SELECT * FROM $urltable");
		
		while(list($id, $name, $alias, $reg_user_only1, $open_direct1, $use_fixed_title1, $auto_resize1, $vsize1) = $result->fields)
		{
			$result->MoveNext();

			// Check if URL is in DB
			if (($alias == $page) || ($name == $page) || ($name == "http://".$page))
			{
				$db_checked = 1;
				$page = $name;
				// Override global settings
				$reg_user_only = $reg_user_only1;
				$open_direct = $open_direct1;
				$use_fixed_title = $use_fixed_title1;
				$auto_resize = $auto_resize1;
				$vsize = $vsize1;
			}
		}
		
		// Nope - display a message and quit
		if(!isset($db_checked))
		{
			$title = (_NOTAUTHHOSTMSG);
			no_display($title);
		}
    }
// CyberOto [---End-------------------------------]

// Store URL parts in array
	$url_parts = parse_url($page);

// Check that a page was specified
	if(!isset($page) || ($page==""))
	{
		$title = _NOPAGEMSG;
		no_display($title);
	}
	
// Check for not entered in browser location window if set
	if(!$HTTP_SERVER_VARS["HTTP_REFERER"] && !$no_user_entry)
	{
		$title = _NOUSERENTRYMSG;
		no_display($title);
	}
	
// Check for not local page if set
	if($allow_local_only &&
		($url_parts['host'] != $HTTP_SERVER_VARS["SERVER_NAME"]) && 
		($url_parts['host'] != $HTTP_SERVER_VARS["HTTP_HOST"])) 
	{
		$title = _NOTLOCALMSG;
		no_display($title);
	}
	
// Check that user is registered and logged in if set
	if(!pnUserLoggedIn() && ($reg_user_only))
	{
		$title = _NOTSERMSG;
		no_display($title);
	}
	
// Everything is good - ready to display

// Use compression if set
	if(!$UseCompression)
	{
		if($use_compression)
		{
			ob_start("ob_gzhandler");
		}
		elseif($use_buffering)
		{
			ob_start();
		}
	}

// Check for fixed title and use it 
	if($use_fixed_title)
	{
		$title = (_TITLEMSG);
		$end_title = (_TITLEMSGEND);
	}
	else
	{
		$title = "";
		$end_title = "";
	}
	
// Add the Open Direct link if set 
	if($open_direct)
	{
		if($use_fixed_title)
		{
			$title .= "<br />[ <a href=\"$page\" target=\"_blank\">"._OPENDIRECTMSG."</a> ]";
			$end_title .= "<br />[ <a href=\"$page\" target=\"_blank\">"._OPENDIRECTMSG."</a> ]";
		}
		else
		{
			$title .= "[ <a href=\"$page\" target=\"_blank\">"._OPENDIRECTMSG."</a> ]";
			$end_title .= "[ <a href=\"$page\" target=\"_blank\">"._OPENDIRECTMSG."</a> ]";
		}
	}
	
// Build and display title and content	
	$content = "\n\n<!-- Begin PostWrap Content -->\n"
		."<div class=\"pn-logo\" align=\"center\">".$title."</div>\n"
		."<iframe src=\"$page\" width=\"100%\" height=\"$vsize\" frameborder=\"0\" marginheight=\"0\" marginwidth=\"0\">\n"
		."  <br />"._SORRYBROWSER."<a href=\"$page\" target=\"_blank\">"._LINKYOU."</a>"._SORRYBROWSER1."<br /><br />\n"
		."</iframe>\n"
		."<div class=\"pn-logo\" align=\"center\">".$end_title."</div>\n"
		."<!-- End PostWrap Content -->\n\n";
			
	echo $content;

// Finish up
    include("footer.php");
	
// If auto_resize then include and call javascript
	if($auto_resize)
	{
		$jscontent = "\n\n<!-- Begin PostWrap Auto Resize -->\n"
			."<script language=\"javascript\" type=\"text/javascript\" src=\"modules/$ModName/javascript/postwrap.js\">\n"
			."</script>\n"
			."<!-- End PostWrap Auto Resize -->\n\n";
	}
	
	echo $jscontent;
	
    if($use_buffering)
    {
		ob_end_flush();
    }
	
// Function called if something is not right and we need to display a message and quit
function no_display($title)
{
	$content =  "\n<div class=\"pn-logo\">".$title."</div>\n";
	echo $content;
	include("footer.php");
	die();
}
?>


