<?php
// $Id: pninit.php,v 1.0 2002/09/01 13:19:41 CyberOto Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: Yassen Yotov
// ----------------------------------------------------------------------
// NOTES: much of this module has been grafted onto the example module 
//        provided with the PostNuke system as "Template".  As such, many
//        of the original comments from this example may remain.  Thus,
//        if a comment seems to make no sense whatsoever, you can likely 
//        safely disregard it =)  Sorry, much was copy / pasted, without 
//        much regard for the timely process of changing comments...
// ----------------------------------------------------------------------

/**
 * initialise the PostWrap module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
 
function PostWrap_init()
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
	
    // It's good practice to name the table and column definitions you
    // are getting - $table and $column don't cut it in more complex
    // modules
	
	$urltable = $pntable['postwrap_url'];
	$urlcolumn = &$pntable['postwrap_url_column'];
	
    // Create the table - the formatting here is not mandatory, but it does
    // make the SQL statement relatively easy to read.  Also, separating out
    // the SQL statement from the Execute() command allows for simpler
    // debug operation if it is ever needed
    $sql = "CREATE TABLE $urltable (
            $urlcolumn[id] int(11) NOT NULL auto_increment,
            $urlcolumn[name] varchar(255) NOT NULL default '',
			$urlcolumn[alias] varchar(50) NOT NULL default '',
			$urlcolumn[reg_user_only] tinyint(2) default NULL,
			$urlcolumn[open_direct] tinyint(2) default NULL,
			$urlcolumn[use_fixed_title] tinyint(2) default NULL,
			$urlcolumn[auto_resize] tinyint(2) default NULL,
			$urlcolumn[vsize] int(4) default NULL,
            PRIMARY KEY(id))";
    $dbconn->Execute($sql);
	
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
        return false;
    }
	
	// Set up an initial value for a module variable.  Note that all module
	// variables should be initialised with some value in this way rather
	// than just left blank, this helps the user-side code and means that
	// there doesn't need to be a check to see if the variable is set in
	// the rest of the code as it always will be
	
	pnModSetVar('PostWrap', 'allow_local_only', "0");	// 1 = display off-site pages, 0 = NO display off-site pages 0*
	pnModSetVar('PostWrap', 'use_buffering', "1");		// 0 = NO buffering output before sending, 1 = buffering output before sending 0*
	pnModSetVar('PostWrap', 'use_compression', "1");	// 0 = NO compressed output, 1 = compressed output 0*
	pnModSetVar('PostWrap', 'reg_user_only', "0");		// 0 = works for everyone, 1 = works for logged in users only 0*
	pnModSetVar('PostWrap', 'no_user_entry', "0");		// 1 = allow input from browser address bar, 0 = NOT allow input from browser address bar 0*
	pnModSetVar('PostWrap', 'open_direct', "0");		// 0 = NO $open_direct_msg link display, 1 = $open_direct_msg link display	0*
	pnModSetVar('PostWrap', 'use_fixed_title', "0");	// 0 = NO title from $title_msg or ptitle, 1 = title from $title_msg or ptitle 0*
	
	// Auto window height calculation (requires Javascript, see the README file)
	pnModSetVar('PostWrap', 'auto_resize', "0");		// 0 = default size
	pnModSetVar('PostWrap', 'vsize', "600");			// set to width of screen size for loaded window 600*
	
	//Set security checkinkg for URL
	pnModSetVar('PostWrap', 'security', "1");			// 0 = NO check with DB, 1 = check with DB) 1*
	// Initialisation successful
	
	return true;
}
 
function PostWrap_upgrade($oldversion)
{
	switch($oldversion) {
        case 1.0:
			PostWrap_upgrade(1.1);
		break;
        case 1.1:
			PostWrap_upgrade(1.2);
		break;
        case 1.2:
		
		    list($dbconn) = pnDBGetConn();
		    $pntable = pnDBGetTables();
			
		    // It's good practice to name the table and column definitions you
		    // are getting - $table and $column don't cut it in more complex
		    // modules
			
			$urltable = $pntable['postwrap_url'];
			$urlcolumn = &$pntable['postwrap_url_column'];
			
		    // Create the table - the formatting here is not mandatory, but it does
		    // make the SQL statement relatively easy to read.  Also, separating out
		    // the SQL statement from the Execute() command allows for simpler
		    // debug operation if it is ever needed
		    $sql = "CREATE TABLE $urltable (
		            $urlcolumn[id] int(11) NOT NULL auto_increment,
		            $urlcolumn[name] varchar(255) NOT NULL default '',
					$urlcolumn[alias] varchar(50) NOT NULL default '',
					$urlcolumn[reg_user_only] tinyint(2) default NULL,
					$urlcolumn[open_direct] tinyint(2) default NULL,
					$urlcolumn[use_fixed_title] tinyint(2) default NULL,
					$urlcolumn[auto_resize] tinyint(2) default NULL,
					$urlcolumn[vsize] int(4) default NULL,
		            PRIMARY KEY(id))";
		    $dbconn->Execute($sql);
			
		    // Check for an error with the database code, and if so set an
		    // appropriate error message and return
		    if ($dbconn->ErrorNo() != 0) {
		        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
		        return false;
		    }
			pnModSetVar('PostWrap', 'allow_local_only', "0");	// 1 = display off-site pages, 0 = NO display off-site pages 0*
			pnModSetVar('PostWrap', 'use_buffering', "1");		// 0 = NO buffering output before sending, 1 = buffering output before sending 0*
			pnModSetVar('PostWrap', 'use_compression', "1");	// 0 = NO compressed output, 1 = compressed output 0*
			pnModSetVar('PostWrap', 'reg_user_only', "0");		// 0 = works for everyone, 1 = works for logged in users only 0*
			pnModSetVar('PostWrap', 'no_user_entry', "0");		// 1 = allow input from browser address bar, 0 = NOT allow input from browser address bar 0*
			pnModSetVar('PostWrap', 'open_direct', "0");		// 0 = NO $open_direct_msg link display, 1 = $open_direct_msg link display	0*
			pnModSetVar('PostWrap', 'use_fixed_title', "0");	// 0 = NO title from $title_msg or ptitle, 1 = title from $title_msg or ptitle 0*
			
			// Auto window height calculation (requires Javascript, see the README file) 			
			pnModSetVar('PostWrap', 'auto_resize', "0");		// 0 = default size
			pnModSetVar('PostWrap', 'vsize', "600");			// set to width of screen size for loaded window 600*
			// Initialisation successful
			//Get Rid of not used vars
			pnModDelVar('PostWrap', 'default_size');
			pnModDelVar('PostWrap', 'use_auth_hosts');
			pnModDelVar('PostWrap', 'auto_resize_type');
			pnModDelVar('PostWrap', 'auto_resize_trim');
			pnModDelVar('PostWrap', 'full_screen');
			pnModDelVar('PostWrap', 'table_borders');
			return true;
		break;
		
		//Just in case someone is using modified ver and its number is >= 1.2
		default:
			pnModSetVar('PostWrap', 'allow_local_only', "0");	// 1 = display off-site pages, 0 = NO display off-site pages 0*
			pnModSetVar('PostWrap', 'use_buffering', "1");		// 0 = NO buffering output before sending, 1 = buffering output before sending 0*
			pnModSetVar('PostWrap', 'use_compression', "1");	// 0 = NO compressed output, 1 = compressed output 0*
			pnModSetVar('PostWrap', 'reg_user_only', "0");		// 0 = works for everyone, 1 = works for logged in users only 0*
			pnModSetVar('PostWrap', 'no_user_entry', "0");		// 1 = allow input from browser address bar, 0 = NOT allow input from browser address bar 0*
			pnModSetVar('PostWrap', 'open_direct', "0");		// 0 = NO $open_direct_msg link display, 1 = $open_direct_msg link display	0*
			pnModSetVar('PostWrap', 'use_fixed_title', "0");	// 0 = NO title from $title_msg or ptitle, 1 = title from $title_msg or ptitle 0*
			
			// Auto window height calculation (requires Javascript, see the README file) 			
			pnModSetVar('PostWrap', 'auto_resize', "0");		// 0 = default size, 1 = maximize 1*
			pnModSetVar('PostWrap', 'vsize', "600");			// set to width of screen size for loaded window 600*
			// Initialisation successful
			//Get Rid of not used vars
			pnModDelVar('PostWrap', 'use_auth_hosts');
			pnModDelVar('PostWrap', 'auto_resize_type');
			pnModDelVar('PostWrap', 'auto_resize_trim');
			pnModDelVar('PostWrap', 'full_screen');
			pnModDelVar('PostWrap', 'table_borders');
			return true;
		break;
}

/**
 * delete the module vars and DB
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function PostWrap_delete()
{
	// Delete module variable
	pnModDelVar('PostWrap', 'allow_local_only');
	pnModDelVar('PostWrap', 'use_buffering');
	pnModDelVar('PostWrap', 'use_compression');
	pnModDelVar('PostWrap', 'reg_user_only');
	pnModDelVar('PostWrap', 'use_auth_hosts');
	pnModDelVar('PostWrap', 'no_user_entry');
	pnModDelVar('PostWrap', 'open_direct');
	pnModDelVar('PostWrap', 'use_fixed_title');
	pnModDelVar('PostWrap', 'auto_resize');
	pnModDelVar('PostWrap', 'auto_resize_type');
	pnModDelVar('PostWrap', 'auto_resize_trim');
	pnModDelVar('PostWrap', 'vsize');
	pnModDelVar('PostWrap', 'full_screen');
	pnModDelVar('PostWrap', 'table_borders');
	// Deletion successful
	
	// Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
	// return arrays but we handle them differently.  For pnDBGetConn()
	// we currently just want the first item, which is the official
	// database handle.  For pnDBGetTables() we want to keep the entire
	// tables array together for easy reference later on
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();
	
	// Drop the table - for such a simple command the advantages of separating
	// out the SQL statement from the Execute() command are minimal, but as
	// this has been done elsewhere it makes sense to stick to a single method
	$sql = "DROP TABLE $pntable[postwrap_url]";
	$dbconn->Execute($sql);
	
	// Check for an error with the database code, and if so set an
	// appropriate error message and return
	if ($dbconn->ErrorNo() != 0)
	{
		// Report failed deletion attempt
		return false;
	}
	return true;
}
?>